Examples
========

For the random movement of a polygon arm with `n` edges, the "toric symplectic Markov Chain Monte Carlo algorithm" (short: TSMCMC) samples the `n`-torus and a convex bounded polytope in `n`-space. Constraints of the movement can be added in form of restrictions of the polytope to a subpolytope defined by finitely many linear inequalities (see :doc:`here <mathBG>` for details)

The function :any:`pwalk.polygif` generates a gif of a random walk from the following data:

- A matrix `A` and a vector `b` such that :math:`Ax \leq b` are the linear inequalities that define   the polytope mentioned above
- A starting point in this polytope
- An `n`-tuple that contains the edge lengths of the polygon arm

For convenience, :any:`pwalk.unconfined` computes `A` and `b` for the polytope of an unconfined walk.

>>> import numpy as np
>>> import pwalk
>>> r = np.ones(n) # Lengths of edges
>>> A, b = pwalk.unconfined(r) # Matrix and vector to define polytope
>>> pwalk.polygif(A, b, np.zeros(n), r, name='RandomWalk', fps=5, size=(800,300), distance=8, t=10)

saves for example the following gif to `RandomWalk.gif`:

.. image:: Animations/rwalk.*

Two contraints on the random walk are the half-space confinement and the slab confinement.
For the former, the polygon arm is only allowed to move  in the upper half-space, while one end is fixed to the origin. For the latter, the polygon arm is only allowed to move in a slab of height `h`. The inequalities to define the corresponding subpolytopes can be generated by :any:`pwalk.slabconfined` and :any:`pwalk.hsconfined`, respectively. See the following examples:

>>> import numpy as np
>>> import pwalk
>>> r = np.ones(8)
>>> A, b = pwalk.unconfined(r)
>>> A_hs, b_hs = pwalk.hsconfined(8)
>>> A = np.concatenate((A_hs, A))
>>> b = np.concatenate((b_hs, b))
>>> pwalk.polygif(A, b, 0.5*np.ones(8), r, name='hsconfwalk', center=False, fps=8, size=(800,300), distance=10, t=10)

.. image:: Animations/hsconfwalk.*

>>> import numpy as np
>>> import pwalk
>>> r = np.ones(12)
>>> h = 1 # height of the slab
>>> A, b = pwalk.unconfined(r)
>>> A_slab, b_slab = pwalk.slabconfined(12, h)
>>> A = np.concatenate((A_slab, A))
>>> b = np.concatenate((b_slab, b))
>>> pwalk.polygif(A, b, np.zeros(n), r, name='./docs/Animations/slabconfwalk', fps=5, size=(800,300), distance=8, t=10)

.. image:: Animations/slabconfwalk.*